FlameWarden = {};
function FlameWarden.IsZoneDesecrated(zone)
	return FlameWardenLog and FlameWardenLog["*" .. zone];
end
function FlameWarden.IsZoneHonoured(zone)
	return FlameWardenLog and FlameWardenLog[zone];
end
function FlameWarden.DesecrateZone(zone)
	FlameWardenLog = FlameWardenLog or {};
	FlameWardenLog["*" .. zone] = select(4, CalendarGetDate());
end
function FlameWarden.HonourZone(zone)
	FlameWardenLog = FlameWardenLog or {};
	FlameWardenLog[zone] = select(4, CalendarGetDate())
end

local events = CreateFrame("Frame", "FlameWardenEventTracker");
local getQuestReward; do
	local pat = "^" .. ERR_QUEST_REWARD_ITEM_MULT_IS:gsub("%.", "%%."):gsub("%%0?1?$?d", "(%%d+)"):gsub("%%0?2?$?s", "(.-)") .. "$";
	function getQuestReward(message)
		local quant, link = message:match(pat);
		if not quant then return; end
		if quant:match("%D") and not link:match("|Hitem:") then
			quant, link = link, quant;
		end
		return tonumber(quant), tonumber(link:match("|Hitem:(%d+)"));
	end
end
local function validateQuest(guid, title, qtype)
	local typeDigit = tonumber(guid:match("^0x%x%x(%x)"), 16) % 8;
	return (typeDigit == 3 and qtype == "honor") or (typeDigit ~= 3 and qtype == "desecrate");
end

local npcGUID, questTitle, matchingGossip;
function events:CHAT_MSG_SYSTEM(message)
	if not matchingGossip then return; end
	local quant, id = getQuestReward(message);
	if quant == 5 and id == 23247 and validateQuest(npcGUID, questTitle, "honor") then
		FlameWarden.HonourZone(GetZoneText());
		matchingGossip = false;
	elseif quant == 10 and id == 23247 and validateQuest(npcGUID, questTitle, ("desecrate")) then
		FlameWarden.DesecrateZone(GetZoneText());
		matchingGossip = false;
	end
end
function events:QUEST_COMPLETE()
	npcGUID, questTitle = UnitGUID("questnpc"), GetTitleText();
end
function events:GOSSIP_SHOW()
	local title, level, flag = GetGossipAvailableQuests();
	matchingGossip = (level == -1 and flag == nil) and select("#", GetGossipAvailableQuests()) == 3 and select("#", GetGossipActiveQuests()) == 0;
end
for k,v in pairs(events) do
	if type(v) == "function" then
		events:RegisterEvent(k);
	end
end

events:SetScript("OnEvent", function(s,e,...) s[e](s, ...); end);